import time
import logging
import paho.mqtt.client as mqtt

def on_connect(client, userdata, flags, rc):
	print ("Connected with result code " + str(rc))
client = mqtt.Client()
client.on_connect = on_connect
client.connect('192.168.5.16','1883',60)



# Constants
timespan_threshhold = 3


logging.getLogger("scapy.runtime").setLevel(logging.ERROR)
from scapy.all import *


def button_pressed_dash1():
	client.publish('Dash-Button/00001/', 'true')
	print ("Button pushed...")



def udp_filter(pkt):
  options = pkt[DHCP].options
  for option in options:
    if isinstance(option, tuple):
      if 'requested_addr' in option:
        # we've found the IP address, which means its the second and final UDP request, so we can trigger our action
        mac_to_action[pkt.src]()
        break
 
 
mac_to_action = {'18:74:2e:49:2d:dd' : button_pressed_dash1}

mac_id_list = list(mac_to_action.keys())

print "Waiting for a Dash-Button press..."
sniff(prn=udp_filter, store=0, filter="udp", lfilter=lambda d: d.src in mac_id_list)

if __name__ == "__main__":
  main()